/**
 * 
 */
package cnh.crb;


/**
 * Constants used by the CNH model.
 * 
 * @author NC
 */
public interface CNHConstants {

	// List is in order of execution:
	
	// First, update the calendar:
	int CAL_UPDATE_PRIORITY                        = 9000;
	
	// Next update any and all climate data:
	int WBM_PRIORITY                               = 8200;
	int RECORD_CLIMATE_PRIORITY                    = 8100; // Note: Only one of these
	int UPDATE_CLIMATE_PRIORITY                    = 8100; // used at a time.
	int SEASONAL_DATA_UPDATE_PRIORITY              = 8000;

	// Allow agents to act given the current climate data:
	// CAP Subcontractor
	int CAWCD_PLANNING_PRIORITY                    = 7300;
	int CAWCD_ROLLOVER_PRIORITY                    = 7200;
	int CAWCD_BOOKKEEPING_PRIORITY                 = 7100;
	int CAP_SUBCONTRACTOR_MONTH_RESET_PRIORITY     = 7000;

	// Distribution of low-flow equipment:
	int DISTRIBUTE_LOW_FLOW_PRIORITY               = 6000;
	
	// Household water use changes:
	int UPDATE_FROM_NGH_PRIORITY                   = 5300;
	int UPDATE_FROM_MESSAGING_PRIORITY             = 5200;
	int UPDATE_FROM_NET_PRIORITY                   = 5100;
	int UPDATE_FROM_PRIOR_USAGE_PRIORITY           = 5000;   // updates based on actual usage prior to current tick

	// Updates to household noise:
	int UPDATE_NOISE_PRIORITY                      = 4000;
	
	// Calculation of household usage:
	int CALC_USE_PRIORITY                          = 3000;   // calculates water usage
	
	// Allow flow through network:
	int FLOW_PRIORITY                              = 2000;   // flows water
	
	// Bill households
	int BILL_PRIORITY                              = 1000;
	
	// Recordkeeping and output
	int HISTOGRAM_RECORD_PRIORITY                  = 100;
	int CAP_SUB_STRATEGY_PRIORITY                  = 90;
	
	String AVG_USE_DIST = "avgWaterUseDist";
	String KE_NETWORK_M = "keNetworkM";
	
	String HOUSEHOLD_NETWORK_ID = "household.network.id";
	
	// parameter names
	String EXO_WEIGHT_PARAMETER = "exogenousWeight";
	String SOCIAL_WEIGHT_PARAMETER = "socialFactorWeight";
	String WATER_USE_DIST_PARAMETER = "waterUseDist";
	String EXO_EFFECTS_PARAMETER = "exogenousEffects";
	String PRICE_WEIGHT_PARAMETER = "priceWeight";
	String WBM_INTERVAL = "wbmInterval";
	String WBM_URL = "wbmURL";
	String WBM_HOST = "wbmHost";
	
	String SOCIAL_FACTOR_DIST_PARAMETER = "socialFactorDist";
	String SOCIAL_FACTOR_THRESHOLD_NWK = "socialFactorThresholdNetwork";
	String SOCIAL_FACTOR_CONVERGENCE_NWK = "socialFactorConvergenceNetwork";
	String SOCIAL_FACTOR_THRESHOLD_NGH = "socialFactorThresholdNeighborhood";
	String SOCIAL_FACTOR_CONVERGENCE_NGH = "socialFactorConvergenceNeighborhood";
	String WATER_USAGE_NOISE = "waterUsageNoise";
	
	
	String RATES_FILE = "ratesFile";
	String SURCHARGE_FILE = "surchargeFile";
	String MONTHLY_CHARGES_FILE = "monthlyChargesFile";
	String CAP_CHARGES_FILE = "capChargesFile";
	String CONSERVE_CHARGES_FILE = "conserveChargesFile";
	String SEWER_RATE_FILE = "sewerRateFile";
	String SEWER_MONTHLY_CHARGES_FILE = "sewerMonthlyFile";
	
	String HOUSEHOLD_INPUT_FILE = "household_input_file";
	String HOUSEHOLD_SAMPLE_PROBABILITY = "household_sample_probability";
	String HOUSEHOLD_NGH_DISTANCE = "household_ngh_distance";
	String NORM_UPDATE_INTERVAL = "neighborhoodUpdates";
	
	String PRICE_MEM_SIZE = "priceMemSize";
	String MAX_PRICE_FACTOR_INCREASE = "maxPriceFactorIncrease";
	String PRICE_FACTOR_INCREASE_SCALE = "priceFactorIncreaseScale";
	String PRICE_FACTOR_DECREASE_DECAY = "priceFactorDecreaseDecay";
	String PRICE_FACTOR_BASE_DECAY = "priceFactorBaseDecay";
	
	String USE_FULL_WATER_FLOW = "useFullWaterFlow";
	
	String CLIMATE_TEMP_IMPACT   = "climateTempImpact";
	String CLIMATE_PRECIP_IMPACT = "climatePrecipImpact";
	
//	double BETA_WATERUSE_MAX = 1540;
	String BETA_WATERUSE_MAX = "betaWaterUseMax";
	
	String NEW_CONST_ANNUAL_FRACTION  = "newConstructionAnnualFraction";
	String LOW_FLOW_ANNUAL_FRACTION   = "lowFlowAnnualFraction";
	String LOW_FLOW_INCREMENT         = "lowFlowIncrement";
	String LOW_FLOW_WEIGHT            = "lowFlowWeight";
	
	String ALLOW_CAP_RETURN           = "allowCAPReturn";
	
	String STOP_AT = "stopAt";
}
