package cnh.crb;

public class FlowAgent {

	enum Direction {
		N(0), NE(45), E(90), SE(135), S(180), SW(225), W(270), NW(315);

		private double heading;

		private Direction(double heading) {
			this.heading = heading;
		}

		protected double getHeading() {
			return heading;
		}

		public static Direction getDirForInt(int i) {
			switch (i) {
			case 1:
				return E;
			case 2:
				return SE;
			case 4:
				return S;
			case 8:
				return SW;
			case 16:
				return W;
			case 32:
				return NW;
			case 64:
				return N;
			case 128:
				return NE;
			}
			return null;
		}
	}

	Direction dir;

	public FlowAgent(int i) {
		this(Direction.getDirForInt(i));
	}

	public FlowAgent(Direction dir) {
		this.dir = dir;
	}

	public double getHeading() {
		return dir.getHeading();
	}
}
