/**
 * 
 */
package cnh.crb;

import java.util.Calendar;

/**
 * Gets the seasonal baseline water offset.
 * 
 * @author nick
 */
public interface SeasonalWaterUse {
	
	/**
	 * Gets the yearly mean water use for the specified year.
	 * 
	 * @param date
	 * 
	 * @return the yearly mean water use for the specified year.
	 */
	float getYearlyMean(Calendar date);
	
	/**
	 * Resets scale factor given the specified data.
	 * 
	 * @param date
	 */
	void resetMonthlyScaleFactor(Calendar date);
	
	/**
	 * Gets the water use scaling factor for the
	 * current month.
	 * 
	 * @return the water use scaling factor for the
	 * current month.
	 */
	float getMonthlyScaleFactor();
	
	/**
	 * Gets the monthly scale factor for the specified date.
	 * 
	 * @param date
	 * 
	 * @return the monthly scale factor for the specified date.
	 */
	float getMonthlyScaleFactorFor(Calendar date);
	

}
