/**
 * 
 */
package cnh.crb;

import java.util.Calendar;

/**
 * Singleton type class for returning the SeasonalWaterUse data.
 * 
 * @author nick
 */
public class SeasonalWaterUseInstance {
	
	// default instance returns 1 for monthly offset from the mean
	private static SeasonalWaterUse instance = new SeasonalWaterUse() {
		@Override
		public void resetMonthlyScaleFactor(Calendar date) {
		}
		
		@Override
		public float getYearlyMean(Calendar date) {
			throw new UnsupportedOperationException();
		}
		
		@Override
		public float getMonthlyScaleFactor() {
			return 1;
		}

		@Override
		public float getMonthlyScaleFactorFor(Calendar date) {
			return 1;
		}
	};
	
	public static void initialize(SeasonalWaterUse waterUse) {
		instance = waterUse;
	}
	
	/**
	 * Gets the SeasonalWaterUse.
	 * 
	 * @return the SeasonalWaterUse.
	 */
	public static SeasonalWaterUse getWaterUse() {
		return instance;
	}

}
