package cnh.crb.analysis;

import java.util.Vector;

public class Combinatorial {
	public static int resultCount = 0;
	
	private class Result{
		int myCount;
		Vector<Integer> array = new Vector<Integer>();
		
		public Result(Result original){
			myCount = resultCount;
			resultCount++;
		  this.array.addAll(original.array);	
		}
		
		public Result(Result original, int n){
			myCount = resultCount;
			resultCount++;
		  this.array.addAll(original.array);
		  concat(n);
		}
		
		
		public Result(){
			myCount = resultCount;
			resultCount++;
		}
		
		public void concat(Object ... objects){
			for(Object o: objects){
				if(o instanceof Integer) array.add((Integer)o);
				if(o instanceof Result){
					for(Integer integer: ((Result)o).array) array.add(integer);
				}
			}
//			System.out.println("Ending concat: " + ret.getString());
		}
		
		public String getString(){
			String ret = "LIST [" + myCount + "]" + " (" + array.size() + "): ";
			for(Integer integer: array) ret += integer.toString() + ", ";
			return ret;
		}
	}
	
	
	
	
	public Vector<Result> getSubset(int n, int k){
		Vector<Result> results = new Vector<Result>();
		Result result = new Result();
		subset(n, k, result, results);
//		System.out.println("Results.size = " + results.size());
//		for(Result r: results) System.out.println(r.getString());
		return results;
	}
	
	private void subset(int n, int k, Result result, Vector<Result> results){
//		System.out.println("CALLING: " + n + " " + k + " with results: " + results.size() + " and result: " + result.getString());
		if(k == 0){
			Result newResult = new Result(result);
//			System.out.println("Adding: " + newResult.getString());
			results.add(newResult);
			return;
		}
		if(n == 0){
			return;
		}
//		System.out.println("Calling n - 1");
		subset(n - 1, k, result, results);
		Result newResult = new Result(result, n-1);
//		System.out.println("Calling n - 1 & k - 1");
		subset(n - 1, k - 1, newResult, results);
		
	}
	
	
	public static void main(String[] args){
		Combinatorial combinatorial = new Combinatorial();
		int bins = 9;
		int balls = 5;
		System.out.println("Bins = " + bins + " Balls = " + balls);
		Vector<Combinatorial.Result> results = combinatorial.getSubset(balls + bins - 1, bins - 1);
		System.out.println("Combinations = " + results.size());
		
		for(int r = 0; r < 10; r++){
			int bin = 1;
			int current = -1;
			Result test = results.get(r);
			System.out.println("TESTING: " + test.getString());
			for(int i = test.array.size() - 1; i >=0; i--){
				int next = test.array.elementAt(i);
				System.out.println("Placing: " + (next - current  - 1) + " into bin " + bin);
				current = next;
				bin++;
			}
			System.out.println("Placing: " + ((balls + bins - 1) - current - 1) + " into bin " + bin);
			System.out.println("END");
		}
		
		System.out.println("Done.");
	}
	
	
	
}
