package cnh.crb.analysis;

import java.util.Calendar;

import cnh.crb.analysis.datasets.DataSetSource;
import cnh.crb.analysis.datasets.DataTrimmerResampler;
import cnh.crb.analysis.datasets.MonthlyAverageResampler;
import cnh.crb.analysis.datasets.SingleDataSet;

/**
 * Gets the service count and usage histogram data for a specific run.
 * 
 * @author murphy
 *
 */
public class ServiceCountAndUsageViewer {

	public static void main(String[] args){

		String versions[][] = {{ "SERVICE_COUNTS",  "SERVICE_COUNT" },
		                       { "USAGE_HISTOGRAM", "USAGE_HIST"}};
		int version = 1; // Set this to choose whether to do service counts or usage 
		
		int runNumber = 205; // Select the run to view
		
		String kind = versions[version][0];
		String name = versions[version][1];
				
		Calendar start = Calendar.getInstance();
		start.set(1993, 0, 1, 0, 0, 0);
		start.set(Calendar.MILLISECOND, 0);
		
		MonthlyAverageResampler maResampler = new MonthlyAverageResampler(true);
		
		Calendar trimStart = Calendar.getInstance();
		trimStart.set(1996, 0, 1, 0, 0, 0);
		trimStart.set(Calendar.MILLISECOND, 0);
		
		Calendar trimEnd = Calendar.getInstance();
		trimEnd.set(2013, 0, 1, 0, 0, 0);
		trimEnd.set(Calendar.MILLISECOND, 0);
		
		DataTrimmerResampler dateTrim = new DataTrimmerResampler(trimStart.getTime(), trimEnd.getTime());
		
		DataSetSource dsSource = 
				new DataSetSource(
						"./out/analysis/MERGED/merged_params.txt", 
						"./out/analysis/MERGED/" + kind + "/",
						name, 
						"./out/analysis/MERGED/merged_params.txt");
		
		SingleDataSet dataSet = dsSource.getDataSet(runNumber);
		dataSet.setStartDate(start);
		dataSet = dataSet.resample(maResampler, dateTrim);
		
		dataSet.report(true);
	}
	
}
