package cnh.crb.analysis.datasets;

import java.util.ArrayList;
import java.util.List;
import java.util.Map.Entry;

public class ColumnFilterResampler extends DataResampler{

	List<String> headersToRetain;
	
	public ColumnFilterResampler(String ... columnsToRetain){
		headersToRetain = new ArrayList<String>();
		for(String column: columnsToRetain) headersToRetain.add(column);
		if(!headersToRetain.contains("tick")) headersToRetain.add("tick"); // Always
	}
	
	public ColumnFilterResampler(List<String> originalHeaderList, String ... columnsToEliminate){
		headersToRetain = new ArrayList<String>();
		headersToRetain.addAll(originalHeaderList);
		for(String col: columnsToEliminate) headersToRetain.remove(col);
		if(!headersToRetain.contains("tick")) headersToRetain.add("tick"); // Always
	}
	
	public SingleDataSet resample(SingleDataSet dataSet){
		List<Integer> columnsToKeep = new ArrayList<Integer>();
		List<String> finalHeaders = new ArrayList<String>();
		finalHeaders.addAll(headersToRetain);
		for(String header: headersToRetain){
			if(dataSet.headers.contains(header)) columnsToKeep.add(dataSet.headers.indexOf(header));
			else                                 finalHeaders.remove(header);
		}
		SingleDataSet ret = new SingleDataSet(dataSet);
		ret.headers.clear();
		ret.headers.addAll(finalHeaders);
		for(Entry<Double, List<String>> dataLine: dataSet.data.entrySet()){
			List<String> values = new ArrayList<String>();
			for(Integer index: columnsToKeep) values.add(dataLine.getValue().get(index));
			ret.data.put(dataLine.getKey(), values);
		}
		return ret;
	}
	
}
