package cnh.crb.analysis.datasets;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map.Entry;

public class DataTrimmerResampler extends DataResampler{

	Date   startDate;
	Date   endDate;
	double startTick = -1;
	double endTick   = -1;
	
	private void setTicks(SingleDataSet example){
		if(startDate == null && endDate == null) return;
		startTick = -1;
		endTick   = -1;
		double lastTick = -1;
		for(Double key: example.data.keySet()){
			if(startTick == -1 && startDate != null && example.convertTickToCalendar(key).getTime().compareTo(startDate) >= 0) startTick = key;
			if(endTick   == -1 && endDate   != null && example.convertTickToCalendar(key).getTime().compareTo(endDate)   >= 0) endTick   = lastTick;
			lastTick = key;
		}
		if(endTick == -1) endTick = lastTick;
	}
	
	
	public DataTrimmerResampler(double start, double end){
		startTick = start;
		endTick   = end;
	}
	
	public DataTrimmerResampler(Date startDate, Date endDate){
		this.startDate = startDate;
		this.endDate   = endDate;
	}
	
	public DataTrimmerResampler(Date startDate, Date endDate, SingleDataSet example){
		this.startDate = startDate;
		this.endDate   = endDate;
		setTicks(example);
	}
	
	public SingleDataSet resample(SingleDataSet dataSet) {
		if((startTick == -1) && (endTick == -1)) setTicks(dataSet);
		SingleDataSet ret = new SingleDataSet(dataSet); // Note: structure only
		for(Entry<Double, List<String>> dataLine: dataSet.data.entrySet()){
			double key = dataLine.getKey();
			if(key > endTick) break;
			if(key >= startTick){
				List<String> values = new ArrayList<String>();
				for(String datum: dataLine.getValue()) values.add(datum);
				ret.data.put(dataLine.getKey(), values);
			}
		}
		return ret;
	}

	
	
}
