package cnh.crb.analysis.datasets;

import java.io.File;

public class MidwayOutputFileSplitter extends OutputFileSplitter {

	/**
	 * Gets the file name of an instance of run data on Midway.
	 * 
	 * param outputDirectory the path to the output folder, e.g. "/project/johntmurphy/run150807"
	 * param baseOutputName basic name for the output file, e.g. "output-subcontractor-agg"
	 * param runNumber the number of the run to be retrieved
	 */
	public String getOutputFile(String outputDirectory, String baseOutputName, int runNumber){
	  String ret = "";
	  String outputFolder = outputDirectory + "/instance_" + (runNumber - 1) + "/"; // compensates for instance # = run# - 1
	  try{
		  File outputDir = new File(outputFolder);
		  File[] files = outputDir.listFiles();
		  for(File file: files){
			  String fileName = file.getName();
			  // note that if there are multiple such files in the Dir, it just chooses to use one of them
			  if(fileName.startsWith(baseOutputName) && !fileName.contains("batch_param_map")){
				  ret = file.getAbsolutePath();
				  break;
			  }
		  }
	  }
	  catch(Exception E){
		  System.out.println("Something bad happened when trying to get an output file name");
		  System.out.println(E.getMessage());
	  }
	  return ret;
  }
	
}
