/**
 * 
 */
package cnh.crb.econ;

import java.util.Date;
import java.util.Map;
import java.util.TreeMap;

/**
 * 
 * @author nick
 */
public class AbstractCalculator {
	
	public static class CostData {
		double cost, threshold;
		public CostData(double cost, double threshold) {
			this.cost = cost;
			this.threshold = threshold;
		}
	}
	
	public TreeMap<Date, CostData> valueMap = new TreeMap<>();
	
	/**
	 * Gets the value for the period that includes the specified Date.
	 * 
	 * @param date
	 * @return the value for the period that includes the specified Date.
	 */
	protected CostData getValue(Date date) {
		Map.Entry<Date, CostData> entry = valueMap.floorEntry(date);
		if (entry == null) throw new IllegalArgumentException("No data for the period that includes " + date);
		return entry.getValue();
	}

}
