package cnh.crb.econ;

import java.util.Date;

public class Bill {

	private int days;
	private double CCF;
	private double amt;
	private Date startDate;

	public Bill(Date startDate, int numberOfDays, double consumptionInCCF, double billAmount) {
		days = numberOfDays;
		CCF = consumptionInCCF;
		amt = billAmount;
		this.startDate = startDate;
	}
	
	public Date getStartDate() {
		return startDate;
	}

	public int getNumberOfDays() {
		return days;
	}

	public double getConsumptionInCCF() {
		return CCF;
	}

	public double getBillAmount() {
		return amt;
	}

	public double getUnitPrice() {
		return amt / CCF;
	}
	
	public String toString() {
		return String.format("Bill [startDate: %s, duration: %d, consumption: %f, price: %f]", startDate, days, CCF, amt);
	}

}
