package cnh.crb.econ;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.apache.log4j.Logger;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.engine.schedule.IAction;
import cnh.crb.agent.ResidentialWaterManager;

public class BillAction implements IAction {

	private class FirstAction implements IAction {

		public void execute() {
			action = new BillCustomersAction();
		}
	}

	private class BillCustomersAction implements IAction {

		public void execute() {
			LOGGER.info("Tick: " + RunEnvironment.getInstance().getCurrentSchedule().getTickCount()
					+ ", Billing Customers");
			for (ResidentialWaterManager manager : waterManagers) {
				manager.billCustomers(cal);
			}

		}
	}

	private static Logger LOGGER = Logger.getLogger(BillAction.class);

	private Calendar cal;
	private List<ResidentialWaterManager> waterManagers = new ArrayList<ResidentialWaterManager>();
	private IAction action = new FirstAction();

	public BillAction(Calendar calendar) {
		cal = calendar;
	}

	public void addManager(ResidentialWaterManager manager) {
		waterManagers.add(manager);
	}

	public void execute() {
		action.execute();
	}
}