/**
 * 
 */
package cnh.crb.econ;

import java.util.Date;

/**
 * Interface for classes that calculate a cost based on a Date and an amount.
 * @author nick
 */
public interface CostCalculator {

	/**
	 * Calculates the cost for the specified date and amount.
	 * 
	 * @param date
	 * @param amt
	 * 
	 * @return the cost for the specified date and amount.
	 */
	double calculateCost(Date date, double amt, BillableEntity entity);

}
