package cnh.crb.econ.micro;

public interface MarginalCostCurve {

  public abstract double getMarginalCostAt(double amount);
  
  public abstract double getTotalCostUpTo(double amount);
  
  public double getCostOfNUnitsAt(double start, double N);
  
  /**
   * Given a starting amount (already purchased) and a minimum
   * value, return the point at which the marginal cost described
   * by this curve exceeds the minimum value. Return -1 if the
   * marginal cost on this curve above the start value will never
   * exceed the minimum.
   * @param start
   * @param minCost
   * @return
   */
  public double getAmountAtWhichMarginalCostExceeds(double start, double minCost);
  
  public double getPurchasingPowerOf(double amount, double start);
  
  public String getReport();
  
}
