/**
 * 
 */
package cnh.crb.household;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 * Loads the geographic influence set from a file.
 * 
 * @author NC
 * 
 */
public class InfluenceSetLoader {

	private Map<String, Household> map = new HashMap<>();

	public void addHousehold(Household h) {
		map.put(h.getId(), h);
	}

	public void runBinary(String file) throws IOException {
		try (DataInputStream in = new DataInputStream(new BufferedInputStream(new FileInputStream(
				file)))) {
			int count = in.readInt();
//			System.out.println(count);
			for (int i = 0; i < count; ++i) {
				String hid = in.readUTF();
				//System.out.println(hid);
				Household h = map.get(hid);
				int nghCount = in.readInt();
				//System.out.println(nghCount);
				for (int j = 0; j < nghCount; ++j) {
					String id = in.readUTF();
					Household other = map.get(id);

					if (other == null) {
//						System.out.println("other not found");
					}
					h.addToInfluenceSet(other);
				}
			}
		}
	}

	public void runText(String file) throws IOException {
		try (BufferedReader reader = new BufferedReader(new FileReader(file))) {
			String line = null;
			while ((line = reader.readLine()) != null) {
				String[] vals = line.split(":");
				Household h = map.get(vals[0].trim());
				for (String id : vals[1].trim().split(",")) {
					h.addToInfluenceSet(map.get(id.trim()));
				}
			}
		}
	}

}
