/**
 * 
 */
package cnh.crb.household;

/**
 * Enum encapsulating a person's race.
 * 
 * @author nick
 */
public enum Race {
	
	WHITE,
	BLACK,
	AMER_INDIAN,
	ALASKA_NATIVE,
	TRIBE_OR_NONE,
	ASIAN,
	HAWAIIAN_PAC_ISLANDER,
	OTHER,
	MIX;
	
	/**
	 * Gets the Enum for the specified synth population household
	 * race code.
	 * 
	 * @param code
	 * @return
	 */
	public static Race fromHouseholdCode(int code) {
		if (code < 1 || code > 9) throw new IllegalArgumentException("Code must be in range 1 - 9.");
		return Race.values()[code - 1];	
	}
}
