package cnh.crb.hydro;

import java.util.Date;

public class ConicalStorage extends AbstractStorage{

  protected double baseR;
  protected double topR;
  protected double h;
  protected double coneVolume;
  protected double maxVolume;

  public ConicalStorage(Date startDate, double baseRadius, double topRadius, double height, String id){
    super(startDate, id);
    baseR      = baseRadius;
    topR       = topRadius;
    h          = height;
    coneVolume = baseRadius * baseRadius * Math.PI / 3.0;
    maxVolume  = topRadius * topRadius * Math.PI/3.0 - coneVolume;
  }
  
  public ConicalStorage(Date startDate, double baseRadius, double topRadius, double height, double initialVolumeStored, String id){
    super(initialVolumeStored, startDate, id);
    baseR      = baseRadius;
    topR       = topRadius;
    h          = height;
    coneVolume = baseRadius * baseRadius * Math.PI / 3.0;
    maxVolume  = topRadius * topRadius * Math.PI/3.0 - coneVolume;
  }
  
  
  public double getMaxVolume(){                    return maxVolume;                }
  public double getMaxDepth(){                     return h;                        }
  public double getDepthAtVolume(double volume){   return (volume / maxVolume) * h; }
  public double getVolumeAtDepth(double depth){    return (depth / h) * maxVolume;  }
  
}
