package cnh.crb.hydro;

import java.util.Date;

public class CylindricalStorage extends AbstractStorage {

  protected double r;
  protected double h;
  protected double maxVolume;
  
  public CylindricalStorage(Date startDate, double radius, double height, String id){
    super(startDate, id);
    r = radius;
    h = height;
    maxVolume = h * r * r * Math.PI;
  }

  public CylindricalStorage(Date startDate, double radius, double height, double initialVolumeStored, String id){
    super(initialVolumeStored, startDate, id);
    r = radius;
    h = height;
    maxVolume = h * r * r * Math.PI;
  }
  
  public double getMaxVolume() {                   return maxVolume;               }
  public double getMaxDepth() {                    return h;                       }
  public double getDepthAtVolume(double volume) {  return (volume / maxVolume) * h;  }
  public double getVolumeAtDepth(double depth) {   return (depth / h) * maxVolume;   }

}
