package cnh.crb.hydro;

import java.util.Calendar;

import org.apache.log4j.Logger;

import cnh.crb.agent.DataDrivenDemandWaterManager;
import repast.simphony.engine.schedule.IAction;

/**
 * Action that runs the flow manager.
 * 
 * @author murphy, nc
 *
 */
public class FlowAction implements IAction {

	private FlowManager fm;
	private Calendar cal;
	private FlowFrequency frequency;

	public FlowAction(FlowManager flowManager, Calendar calendar, FlowFrequency frequency) {
		fm = flowManager;
		cal = calendar;
		this.frequency = frequency;
	}

	@Override
	public void execute() {
		DataDrivenDemandWaterManager.setAll(cal.get(Calendar.YEAR), cal.get(Calendar.MONTH));
		Logger.getLogger(getClass()).info("Starting FlowAction...");
		Calendar endCal   = (Calendar) cal.clone();
		endCal.add(Calendar.DAY_OF_YEAR, 1);
		Calendar startCal = (Calendar) endCal.clone();
		frequency.decrementCalendar(startCal);
		fm.flow(startCal.getTime(), endCal.getTime());
	}
}