/**
 * 
 */
package cnh.crb.hydro;

import java.util.Calendar;

/**
 * Enum that describes the frequency with which the flow action is called.
 * 
 * @author nick
 */
public enum FlowFrequency {
	
	DAILY() {
		public void decrementCalendar(Calendar cal) {
			cal.add(Calendar.DAY_OF_YEAR, -1);
		}
	}, 
	
	EVERY_SEVEN_DAYS() {
		public void decrementCalendar(Calendar cal) {
			cal.add(Calendar.DAY_OF_YEAR, -7);
		}
	}, 
	
	MONTHLY() {
		public void decrementCalendar(Calendar cal) {
			cal.add(Calendar.MONTH, -1);
		}
	};
	
	/**
	 * Decrements the specified calendar by the appropriate amount.
	 * For example, DAILY, decrements the calendar by 1 day.
	 */
	public abstract void decrementCalendar(Calendar cal);
}
