package cnh.crb.hydro;

public class FlowRateAFY extends FlowRate{

	public FlowRateAFY(double rate){
        super(UnitsAndConverters.AFY_To_M3S(rate), UnitsAndConverters.AFY_To_GPD(rate),
              UnitsAndConverters.AFY_To_GPM(rate), rate, FlowRateUnits.AFY);
	}

	public FlowRateAFY copy(){
		return new FlowRateAFY(afy);
	}
	
	public double getRate(){
		return afy;
	}
	
    public FlowRateAFY getSum(FlowRate flowRate){
	  return new FlowRateAFY(afy + flowRate.getRateAFY());
    }
  
    public FlowRateAFY getDiff(FlowRate flowRate){
	  return new FlowRateAFY(afy - flowRate.getRateAFY());
    }
  
    public FlowRateAFY getProduct(double scalar){
	  return new FlowRateAFY(afy * scalar);
    }
    
    public int compare(FlowRate other){
  	  return (this.afy > other.afy ? 1 : (this.afy == other.afy ? 0 : -1));
  	// TODO Add epsilon to allow for conversion
//  	  if(other.nativeUnits == nativeUnits) return (this.afy > other.afy ? 1 : (this.afy == other.afy ? 0 : -1));
//  	  return (this.afy > other.afy ? 1 : (this.afy == other.afy ? 0 : -1)); 
    }
    
}
