package cnh.crb.hydro;

public class FlowRateGPD extends FlowRate{

	
	public FlowRateGPD(double rate){
		super(UnitsAndConverters.GPD_To_M3S(rate), rate,
			  UnitsAndConverters.GPD_To_GPM(rate), UnitsAndConverters.GPD_To_AFY(rate), 
			  FlowRateUnits.GPD);
	}
	
	public FlowRateGPD copy(){
		return new FlowRateGPD(gpd);
	}
	
	public double getRate(){
		return gpd;
	}
	
    public FlowRateGPD getSum(FlowRate flowRate){
	  return new FlowRateGPD(gpd + flowRate.getRateGPD());
    }
  
    public FlowRateGPD getDiff(FlowRate flowRate){
	  return new FlowRateGPD(gpd - flowRate.getRateGPD());
    }
  
    public FlowRateGPD getProduct(double scalar){
	  return new FlowRateGPD(gpd * scalar);
    }
    
    public int compare(FlowRate other){
    	  return (this.gpd > other.gpd ? 1 : (this.gpd == other.gpd ? 0 : -1));
    	// TODO Add epsilon to allow for conversion
//    	  if(other.nativeUnits == nativeUnits) return (this.gpd > other.gpd ? 1 : (this.gpd == other.gpd ? 0 : -1));
//    	  return (this.gpd > other.gpd ? 1 : (this.gpd == other.gpd ? 0 : -1)); 
      }
      
}
