package cnh.crb.hydro;

public class FlowRateGPM extends FlowRate{

	public FlowRateGPM(double rate){
		super(UnitsAndConverters.GPM_To_M3S(rate), UnitsAndConverters.GPM_To_GPD(rate), 
			  rate, UnitsAndConverters.GPM_To_AFY(rate), FlowRateUnits.GPM);
	}

	public FlowRateGPM copy(){
		return new FlowRateGPM(gpm);
	}
	
	public double getRate(){
		return gpm;
	}
	
    public FlowRateGPM getSum(FlowRate flowRate){
	  return new FlowRateGPM(gpm + flowRate.getRateGPM());
    }
  
    public FlowRateGPM getDiff(FlowRate flowRate){
	  return new FlowRateGPM(gpm - flowRate.getRateGPM());
    }
  
    public FlowRateGPM getProduct(double scalar){
	  return new FlowRateGPM(gpm * scalar);
    }

    public int compare(FlowRate other){
    	  return (this.gpm > other.gpm ? 1 : (this.gpm == other.gpm ? 0 : -1));
    	// TODO Add epsilon to allow for conversion
//    	  if(other.nativeUnits == nativeUnits) return (this.gpm > other.gpm ? 1 : (this.gpm == other.gpm ? 0 : -1));
//    	  return (this.gpm > other.gpm ? 1 : (this.gpm == other.gpm ? 0 : -1)); 
      }
    
}
