package cnh.crb.hydro;


public class FlowRateM3S extends FlowRate {

	
	public FlowRateM3S(double rate){
        super(rate, UnitsAndConverters.M3S_To_GPD(rate), UnitsAndConverters.M3S_To_GPM(rate), UnitsAndConverters.M3S_To_AFY(rate), FlowRate.FlowRateUnits.M3S);
	}

	public FlowRateM3S copy(){
		return new FlowRateM3S(m3s);
	}
	
	public double getRate(){
		return m3s;
	}
	
    public FlowRateM3S getSum(FlowRate flowRate){
	  return new FlowRateM3S(m3s + flowRate.getRateM3S());
    }
  
    public FlowRateM3S getDiff(FlowRate flowRate){
	  return new FlowRateM3S(m3s - flowRate.getRateM3S());
    }
  
    public FlowRateM3S getProduct(double scalar){
	  return new FlowRateM3S(m3s * scalar);
    }
    
    public int compare(FlowRate other){
  	  return (this.m3s > other.m3s ? 1 : (this.m3s == other.m3s ? 0 : -1));
  	// TODO Add epsilon to allow for conversion
//  	  if(other.nativeUnits == nativeUnits) return (this.m3s > other.m3s ? 1 : (this.m3s == other.m3s ? 0 : -1));
//  	  return (this.m3s > other.m3s ? 1 : (this.m3s == other.m3s ? 0 : -1)); 
    }

}
