package cnh.crb.hydro;


/**
 * Any water source should be able to provide FlowHydrographs
 * that indicate how much water is available to specific
 * recipients.
 * 
 * @author murphy
 *
 */
public interface SourceFlowNode extends FlowNode{
  
  public void addWaterRecipient(RecipientFlowNode recipient);

  /**
   * Register the demand that a downstream user is requesting
   * or expecting. This is used to calculate demand
   * required by this node; this is eventually passed
   * to upstream node using this method on the
   * upstream instance.
   * @param demand
   * @param flowManager TODO
   * @param recipient
   */
  public void registerDemandRequest(RecipientFlowNode downstreamNode, FlowHydrograph demand, FlowManager flowManager);
  
}
