package cnh.crb.hydro;

import java.util.Date;

public interface Storage {

  public double getMaxVolume();
  public double getMaxDepth();
  public double getDepthAtVolume(double volume);
  public double getVolumeAtDepth(double depth);
  public VolumeHydrograph getVolumeHydrograph(Date toDate);
  
  // Return true if completely successful, false if volume would be negative at any point
  public boolean flowToDate(Date flowToDate);
  
  public void addInflowHydrograph(FlowHydrograph inflow);
  public void removeInflowHydrograph(FlowHydrograph inflow);
  public void addOutflowHydrograph(FlowHydrograph outflow);
  public void removeOutflowHydrograph(FlowHydrograph outflow);

  public double getCurrentVolume();
  
  public void setToMax();
  public void setVolumeStored(double newVolume);
  
}
