package cnh.crb.hydro;

/**
 * A WaterRequest object is a message that is passed
 * between two nodes in a flow network, or a memo
 * for a FlowNode to record what it is sending or
 * has sent. In all cases the WaterRequest consists of 
 * two flow hydrographs. However, the meaning of those 
 * two hydrographs can vary; this will depend
 * on the child class.
 * 
 * @author murphy
 *
 */
public class WaterRequest{
  public FlowHydrograph hydrograph1;
  public FlowHydrograph hydrograph2;
  
  public WaterRequest(FlowHydrograph hydro1, FlowHydrograph hydro2){
    hydrograph1 = (hydro1 == null ? new FlowHydrograph() : hydro1);
    hydrograph2 = (hydro2 == null ? new FlowHydrograph() : hydro2);
  }
  
  public boolean equals(WaterRequest other){
    return this.hydrograph1.equals(other.hydrograph1) &&
           this.hydrograph2.equals(other.hydrograph2);
  }
  
}