package cnh.crb.hydro;

import cnh.crb.hydro.UnitsAndConverters.VolumeUnits;

public interface WaterSink {

	public enum WATER_SINK_METHOD { RETURN_TO_SURFACE, RETURN_TO_GROUNDWATER, ADD_TO_UNSUSTAINABLE, EVAPORATE, DELTA_STORE };
	
	public String getId();

	public void eliminateWater(double volume, VolumeUnits units, WATER_SINK_METHOD method);
	
	
	// Must add the flows already contributed to one water sink into another
	public void addWaterSinkAmounts(WaterSink other);
	
	// Sinks may track amount stored
	public void notifyStorage(double storage);
	
}
