/**
 * 
 */
package cnh.crb.parameter;

import java.util.HashMap;
import java.util.Map;

import repast.simphony.parameter.IllegalParameterException;
import repast.simphony.parameter.StringConverter;

/**
 * String converter for creating a distribution.
 * 
 * @author Nick Collier
 */
public class DistributionConverter implements StringConverter<DistributionParameter> {
	
	private static int counter = 1;

	/* (non-Javadoc)
	 * @see repast.simphony.parameter.StringConverter#toString(java.lang.Object)
	 */
	@Override
	public String toString(DistributionParameter obj) {
		return obj.toString();
	}

	/* (non-Javadoc)
	 * @see repast.simphony.parameter.StringConverter#fromString(java.lang.String)
	 */
	@Override
	public DistributionParameter fromString(String strRep) {
		String[] vals = strRep.trim().split(" ");
		String type = vals[0];
		String name = type + "_" + counter;
		counter++;
		Map<String, String> params = new HashMap<String, String>();
		if (vals.length > 1) {
			if ((vals.length - 1) % 2 != 0) throw new IllegalParameterException("Distribution Parameter has invalid number of arguments");
			for (int i = 1; i < vals.length; i += 2) {
				params.put(vals[i], vals[i + 1]);
			}
		}
		
		return new DistributionParameter(name, type, params);
	}
}
