package cnh.crb.regional.tucson;

import java.util.Date;
import java.util.Map;

import cnh.crb.econ.SurchargeCalculator;
import cnh.crb.econ.SurchargeCalculator.Surcharge;
import cnh.crb.econ.io.SurchargeLoader;

public class TucsonSummerSurchargeLoader extends SurchargeLoader {

	double defaultVal;
	
	public TucsonSummerSurchargeLoader(double initialDefaultValue){
		defaultVal = initialDefaultValue;
	}
	
	@Override
	public SurchargeCalculator getSurchargeCalculator(Map<Date, Surcharge> map) {
		TucsonHouseholdSummerSurchargeCalculator surchargeCalc = new TucsonHouseholdSummerSurchargeCalculator(map);
		surchargeCalc.setGlobalDefault(defaultVal);
		return surchargeCalc;
	}

}
