package cnh.crb.wbm;

import org.zeromq.ZMQ;

//######################################################################
//
//     ZMQ ABM test
//
//     Written by Stanley Glidden (Stanley.Glidden@unh.edu)
//
//######################################################################


public class zmq_abm {

public static void main(String[] args) throws Exception{
	System.out.println("RUNNING");
ZMQ.Context context = ZMQ.context(1);

//Socket to talk to WBM
ZMQ.Socket req = context.socket(ZMQ.REQ);
req.connect("tcp://132.177.243.38:5562");

//req.bind("tcp://0.0.0.0:5562");

System.out.println("Sending message to WBM with sites");
String sites = new String ( "lat,lon,taken\n32.2217,-110.9264,0\n" );
req.send(sites.getBytes(), 0);

//Simulate ABM model execution (loop)
while (!Thread.currentThread().isInterrupted()) {
	// Wait for WBM exchange files to be ready
byte[] request = req.recv(0);
String msg = new String ( request );
System.out.println("Received WBM message: " + msg);
if (msg.equals("END")) { break; }

	// Do some 'work'- Pretending it runs the model
Thread.sleep(1000);

	// Send message to WBM that exchange files are ready (the semaphore)
System.out.println("Sending message to WBM after 1 sec");
String reply = "lat,lon,taken\n32.2217,-110.9264,10\n";
req.send(reply.getBytes(), 0);
}
req.close();
context.term();

}
}